#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define TRUE 1
#define FALSE 0

// number of cycles for LOCK and UNLOCK
#define LK_SIZE 60 
#define LK_SIZE_UNLOCKED 10 
#define ULK_SIZE 20 

// Number of unfoldings
#define UNFOLDINGS 10

// inputs
_Bool L; // Left flasher command
_Bool R; // Right flasher command
_Bool W; // Warning command
_Bool LK; // LocK command
_Bool ULK; // UnLocK command
_Bool F; // Flashing function active command
_Bool in18=1; // always one ! 

// outputs
_Bool outL=0; // left light
_Bool outR=0; // right light

// internal variables
int counter_a_DSTATE;
int counter_b_DSTATE;
int Unit_Delay1_d_DSTATE;
int Unit_Delay1_f_DSTATE;
int Unit_Delay1_h_DSTATE;
int Unit_Delay1_j_DSTATE;
int Unit_Delay1_b_DSTATE;
_Bool Unit_Delay_c_DSTATE;
_Bool Unit_Delay_e_DSTATE;
_Bool Unit_Delay_h_DSTATE;
_Bool Unit_Delay3_c_DSTATE;
_Bool Unit_Delay_i_DSTATE;
_Bool Unit_Delay_j_DSTATE;
_Bool Unit_Delay_a_DSTATE;
_Bool Unit_Delay_b_DSTATE;
_Bool Unit_Delay3_a_DSTATE;
_Bool Unit_Delay_d_DSTATE;
_Bool Unit_Delay_f_DSTATE;
_Bool Unit_Delay3_b_DSTATE;
_Bool Unit_Delay3_d_DSTATE;
_Bool Unit_Delay3_e_DSTATE;
_Bool Unit_Delay1_a_DSTATE;
_Bool Unit_Delay1_c_DSTATE;
_Bool Unit_Delay1_e_DSTATE;
_Bool Unit_Delay1_g_DSTATE;
_Bool Unit_Delay1_i_DSTATE;
_Bool Unit_Delay_g_DSTATE;
int Switch7;
int Switch1_m;
int add_g;
int Switch1_k;
int add_f;
int Switch1_i;
int add_e;
int Switch_e;
int add_d;
int Switch_d;
int add_c;
int Switch1_e;
int add_b;
int Switch1_c;
int add_a;
_Bool Data_Type_Conversion_a;
_Bool Switch5;
_Bool Switch4_a;
_Bool OR;
_Bool Switch6;
_Bool Switch2_a;
_Bool Switch3_a;
_Bool superior_e;
_Bool Switch3_f;
_Bool Switch1_l;
_Bool Switch2_f;
_Bool Switch4_f;
_Bool and1_d;
_Bool superior_d;
_Bool Switch3_e;
_Bool Switch1_j;
_Bool Switch2_e;
_Bool Switch4_e;
_Bool and1_c;
_Bool Switch_g;
_Bool Logical_Operator2;
_Bool superior_c;
_Bool Switch3_d;
_Bool Switch1_h;
_Bool Switch2_d;
_Bool Switch4_d;
_Bool and1_b;
_Bool Data_Type_Conversion_d;
_Bool Data_Type_Conversion_c;
_Bool Unit_Delay_g;
_Bool Multiport_Switch;
_Bool and_e;
_Bool superior_b;
_Bool Switch3_c;
_Bool Switch1_d;
_Bool Switch2_c;
_Bool Switch4_c;
_Bool and_d;
_Bool superior_a;
_Bool Switch3_b;
_Bool Switch1_b;
_Bool Switch2_b;
_Bool Switch4_b;
_Bool and1_a;
_Bool and_c;
_Bool and_b;
_Bool Switch1_a;
_Bool Switch_a;
_Bool Warning_Acti_ZCE;
int rtb_Switch_i;
int rtb_Switch_h;
int rtb_Switch_f;
int rtb_Switch1_g;
int rtb_Switch1_f;
int rtb_Switch_c;
int rtb_Switch_b;
_Bool rtb_and_a;
_Bool rtb_Logical_Operator;
_Bool rtb_Logical_Operator1;

// function that implements the simulink module
#include "f1.c"

_Bool nondet_in(); // to represent non deterministic inputs



/*****************************/
// initializations
/*****************************/
void init(void){
  counter_a_DSTATE = 0;
  counter_b_DSTATE= 0;
  Unit_Delay1_d_DSTATE= 0;
  Unit_Delay1_f_DSTATE= 0;
  Unit_Delay1_h_DSTATE= 0;
  Unit_Delay1_j_DSTATE= 0;
  Unit_Delay1_b_DSTATE= 0;
  Unit_Delay_c_DSTATE = FALSE;
  Unit_Delay_e_DSTATE = FALSE;
  Unit_Delay_h_DSTATE = FALSE;
  Unit_Delay3_c_DSTATE = FALSE;
  Unit_Delay_i_DSTATE = FALSE;
  Unit_Delay_j_DSTATE = FALSE;
  Unit_Delay_a_DSTATE = FALSE;
  Unit_Delay_b_DSTATE = FALSE;
  Unit_Delay3_a_DSTATE = FALSE;
  Unit_Delay_d_DSTATE = FALSE;
  Unit_Delay_f_DSTATE = FALSE;
  Unit_Delay3_b_DSTATE = FALSE;
  Unit_Delay3_d_DSTATE = FALSE;
  Unit_Delay3_e_DSTATE = FALSE;
  Unit_Delay1_a_DSTATE = FALSE;
  Unit_Delay1_c_DSTATE = FALSE;
  Unit_Delay1_e_DSTATE = FALSE;
  Unit_Delay1_g_DSTATE = FALSE;
  Unit_Delay1_i_DSTATE = FALSE;
  Unit_Delay_g_DSTATE = FALSE;
  Switch7 = 0;
  Switch1_m = 0;
  add_g = 0;
  Switch1_k = 0;
  add_f = 0;
  Switch1_i = 0;
  add_e = 0;
  Switch_e = 0;
  add_d = 0;
  Switch_d = 0;
  add_c = 0;
  Switch1_e = 0;
  add_b = 0;
  Switch1_c = 0;
  add_a = 0;
  Data_Type_Conversion_a = FALSE;
  Switch5 = FALSE;
  Switch4_a = FALSE;
  OR = FALSE;
  Switch6 = FALSE;
  Switch2_a = FALSE;
  Switch3_a = FALSE;
  superior_e = FALSE;
  Switch3_f = FALSE;
  Switch1_l = FALSE;
  Switch2_f = FALSE;
  Switch4_f = FALSE;
  and1_d = FALSE;
  superior_d = FALSE;
  Switch3_e = FALSE;
  Switch1_j = FALSE;
  Switch2_e = FALSE;
  Switch4_e = FALSE;
  and1_c = FALSE;
  Switch_g = FALSE;
  Logical_Operator2 = FALSE;
  superior_c = FALSE;
  Switch3_d = FALSE;
  Switch1_h = FALSE;
  Switch2_d = FALSE;
  Switch4_d = FALSE;
  and1_b = FALSE;
  Data_Type_Conversion_d = FALSE;
  Data_Type_Conversion_c = FALSE;
  Unit_Delay_g = FALSE;
  Multiport_Switch = FALSE;
  and_e = FALSE;
  superior_b = FALSE;
  Switch3_c = FALSE;
  Switch1_d = FALSE;
  Switch2_c = FALSE;
  Switch4_c = FALSE;
  and_d = FALSE;
  superior_a = FALSE;
  Switch3_b = FALSE;
  Switch1_b = FALSE;
  Switch2_b = FALSE;
  Switch4_b = FALSE;
  and1_a = FALSE;
  and_c = FALSE;
  and_b = FALSE;
  Switch1_a = FALSE;
  Switch_a = FALSE;
  Warning_Acti_ZCE = FALSE;
  rtb_Switch_i = 0;
  rtb_Switch_h = 0;
  rtb_Switch_f = 0;
  rtb_Switch1_g = 0;
  rtb_Switch1_f = 0;
  rtb_Switch_c = 0;
  rtb_Switch_b = 0;
  rtb_and_a = FALSE;
  rtb_Logical_Operator = FALSE;
  rtb_Logical_Operator1 = FALSE;
}


/*****************************/
// property 2
/*****************************/

void p2() {
  int d = UNFOLDINGS;

  _Bool oldW;
  _Bool Won = FALSE;
  int cpt=0;
  int countR=-1;
  int countL=-2;

  init();

  LK=FALSE;
  ULK=FALSE;

  F=TRUE;	

  while (cpt<d) {
    cpt++;

    L=nondet_in();
    if (L) 
      R=FALSE; 
    else 
      R=nondet_in();

    if (R) 
      countR++; 
    else 
      countR=-1;

    if (L) 
      countL++; 
    else 
      countL=-2;

    oldW=W;
    W=nondet_in();
    if (W && !oldW){
      Won = !Won;
    }

    f1();
      
    if ((Won && R) || (Won && L)) {
      int cpt2=0;

      while (cpt2<d && Won) {
	cpt2++;

	oldW=W;
	W=nondet_in();
	if (W && !oldW){
	  Won = !Won;
	}
	if (R) countR++;
	if (L) countL++;
	f1();
      }

      if (!Won && R) {
	if ((countR/3)%2==0)
	  assert(outL==FALSE && outR==TRUE);
	else
	  assert(outL==FALSE && outR==FALSE);	  
      }
      if (!Won && L) {
	if (countL==-1 || (countL/3)%2==0)
	  assert(outL==TRUE && outR==FALSE);
	else
	  assert(outL==FALSE && outR==FALSE);
      }
    }
  }
}
